#ifndef __ARVORE23_H
#define __ARVORE23_H


typedef struct ST_NODE_23 {
	const void *v[2];
	struct ST_NODE_23 *f[3];
} NODE_23_T;

typedef struct ST_TREE_23_T {
	NODE_23_T *tree;
	int (*cmp)(const void *, const void *);
	unsigned long n; /* quantidade atual de elementos na rvore */
} TREE_23_ST;
typedef TREE_23_ST *ARVORE_23_T;


const void *Arvore23RecuperaUltimo (ARVORE_23_T tree23);
ARVORE_23_T Arvore23Criacao (int (*cmp)(const void *, const void *));
const void *Arvore23Insere (ARVORE_23_T tree23, const void *el);
const void *Arvore23Remove (ARVORE_23_T tree23, const void *valor);
void Arvore23Destroi (ARVORE_23_T tree23);
const void *Arvore23Recupera (ARVORE_23_T tree23, const void *el);
int Arvore23Contem (ARVORE_23_T tree23, const void *valor);
void Arvore23Apagar (ARVORE_23_T tree23);
int Arvore23Valida (ARVORE_23_T tree23);
void Arvore23DestroiDesalocaDados (ARVORE_23_T tree23);
const void *Arvore23RecuperaProximo (ARVORE_23_T tree23, const void *el);
const void *Arvore23RecuperaAnterior (ARVORE_23_T tree23, const void *el);
const void *Arvore23RecuperaTeto (ARVORE_23_T tree23, const void *el);
const void *Arvore23RecuperaChao (ARVORE_23_T tree23, const void *el);
const void *Arvore23RecuperaPrimeiro (ARVORE_23_T tree23);
long Arvore23GeraLista (ARVORE_23_T tree23, const void *lista[]);
int Arvore23Altura (ARVORE_23_T tree23);
unsigned long Arvore23Tamanho (ARVORE_23_T tree23);

#endif
